/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.weather.component;

import java.util.List;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.container.client.http.HttpClientInfo;
import org.exoplatform.faces.core.component.UIInput;

public class UISelectList extends UIInput {

	protected String value_ ;
	private List options_ ;

	public UISelectList(String name, String value, List options) {
		super();
		name_ = name ;
		value_ = value;
		options_ = options ;
		setId(name) ;
		
    HttpClientInfo client = 
      (HttpClientInfo)SessionContainer.getInstance().getMonitor().getClientInfo();
    String type = client.getClientType() ;
    if (type.equals(HttpClientInfo.MOBILE_BROWSER_TYPE)) {
      setRendererType("XHTMLMPSelectListRenderer");
		} else {
		  setRendererType("SelectListRenderer");
		}
	}

	final public String getValue() { return value_ ; }

	final public UISelectList setValue(String s) { 
		value_ = s ; 
		return this ;
	}

	final public List getOptions() { return options_ ; }

	final public UISelectList setOptions(List options) { 
		options_ = options ; 
		return this ;
	}
}

