/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.communication.forum.hibernate;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;
import net.sf.hibernate.Session;
import org.exoplatform.services.backup.ImporterExporter;
import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.XppDriver;
import com.thoughtworks.xstream.converters.extended.SqlTimestampConverter ;
/**
 * May 27, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $ID$
 **/
public class ForumImporterExporter implements ImporterExporter {
  private XStream xstream_ ; 

  public ForumImporterExporter() {
    xstream_ = new XStream(new XppDriver());
    xstream_.alias("category", CategoryImpl.class);
    xstream_.alias("forum", ForumImpl.class);
    xstream_.alias("topic", TopicImpl.class);
    xstream_.alias("forum-topic", TopicBackup.class);
    xstream_.alias("post", PostImpl.class);
    xstream_.registerConverter(new SqlTimestampConverter()) ;
  }
  
  public String getName() {    return  "forum" ;}
  
  public String getDescription() {
    return "Export  categories, forums , topics , posts" ;
  }

  public void exportUserData(String userName, Object transaction,
                             OutputStream out, JarEntry entry) throws Exception {
  }

  public void importUserData(String userName, Object transaction, 
                             InputStream is, JarEntry entry) throws Exception {
  }

  public void exportServiceData(Object transaction, JarOutputStream out) throws Exception {
    Session session = (Session) transaction ;
    ForumExporter exporter = new ForumExporter(session, out, xstream_) ;
    exporter.export() ;
  }

  public void importServiceData(Object transaction, JarFile jar) throws Exception {
  	Session session = (Session) transaction ;
    ForumImporter importer = new ForumImporter(session,jar, xstream_) ;
    importer.importData() ;
  }
}