package org.exoplatform.services.portletcontainer.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;

import javax.portlet.PortletMode;
import javax.portlet.WindowState;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.exoplatform.Constants;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.log.LogService;
import org.exoplatform.services.portletcontainer.*;
import org.exoplatform.services.portletcontainer.pci.*;
import org.exoplatform.services.portletcontainer.pci.model.*;
import org.picocontainer.MutablePicoContainer;
import org.picocontainer.Startable;


/**
 * Created by the Exo Development team.
 * Author : Mestrallet Benjamin
 * benjamin.mestrallet@exoplatform.com
 */
public class PortletContainerServiceImpl implements PortletContainerService, Startable   {

  private Log log;  
  private PortletApplicationsHolder holder_;
  private MutablePicoContainer subcontainer_ = null;
  private LogService logService_ ;
  private PortletContainerDispatcher dispatcher_;

  public PortletContainerServiceImpl(PortletApplicationsHolder holder,
      PortletContainerDispatcher dispatcher,
      LogService logService) {
  	logService_ = logService ;  	
    holder_ = holder;
    dispatcher_ = dispatcher;
  	this.log = logService_.getLog(getClass());
  } 
  
  public void start() {  }
  
  public void stop() { } 

  public void setPortletContainerName(String containerName) {
    dispatcher_.setPortletContainerName(containerName);
  }

  public void setMajorVersion(int majorVersion) {
    dispatcher_.setMajorVersion(majorVersion);
  }

  public void setMinorVersion(int minorVersion) {
    dispatcher_.setMinorVersion(minorVersion);
  }

  public void setProperties(Map properties) {
    dispatcher_.setProperties(properties);
  }

  public void setSupportedPortletModesWithDescriptions(Collection portletModes) {
    dispatcher_.setSupportedPortletModesWithDescriptions(portletModes);
  }

  public void setSupportedWindowStatesWithDescriptions(Collection windowStates) {
    dispatcher_.setSupportedWindowStatesWithDescriptions(windowStates);
  }

  public Collection getSupportedPortletModes() {
    return dispatcher_.getSupportedPortletModes();
  }

  public Collection getSupportedWindowStates() {
    return dispatcher_.getSupportedWindowStates();
  }

  public Collection getSupportedPortletModesWithDescriptions() {
    return dispatcher_.getSupportedPortletModesWithDescriptions();
  }

  public Collection getSupportedWindowStatesWithDescriptions() {
    return dispatcher_.getSupportedWindowStatesWithDescriptions();
  }

  public Collection getPortletModes(String portletAppName, String portletName, String markup) {
    return dispatcher_.getPortletModes(portletAppName, portletName, markup);
  }

  public boolean isModeSuported(String portletAppName, String portletName, String markup, PortletMode mode) {
    return dispatcher_.isModeSuported(portletAppName, portletName, markup, mode);
  }

  public Collection getWindowStates(String portletApplicationName) {
    return dispatcher_.getWindowStates(portletApplicationName);
  }

  public boolean isStateSupported(WindowState state, String portletApplication) {
    return dispatcher_.isStateSupported(state, portletApplication);
  }

  public Map getAllPortletMetaData() {
    return dispatcher_.getAllPortletMetaData();
  }

  public ResourceBundle getBundle(HttpServletRequest request, HttpServletResponse response,
                                  String portletAppName, String portletName, Locale locale)
      throws PortletContainerException {
    return dispatcher_.getBundle(request, response, portletAppName, portletName, locale);
  }

  public void setPortletPreference(Input input, Map preferences) throws PortletContainerException {
    dispatcher_.setPortletPreference(input, preferences);
  }

  public Map getPortletPreference(Input input) {
    return dispatcher_.getPortletPreference(input);
  }

  public ActionOutput processAction(HttpServletRequest request, HttpServletResponse response,
                                    ActionInput input) throws PortletContainerException {
    return dispatcher_.processAction(request, response, input);
  }

  public RenderOutput render(HttpServletRequest request, HttpServletResponse response, RenderInput input)
      throws PortletContainerException {
    return dispatcher_.render(request, response, input);
  }

}
